import java.awt.*;
import java.awt.event.*;
public class LUDecomp extends Frame
{
   public LUDecomp()
   {  
      setSize(800,300);
      addWindowListener(new WindowAdapter()
      {
         public void windowClosing(WindowEvent e){System.exit(0);}
      });
   }
   public void MultM(double [][] A,double [][] B,double [][] C,int N1,int N2, int N3)
   {
      int i,j,k;
      for(i=0;i<N1;i++) for(j=0;j<N3; j++)
      {  C[i][j]=0.0;
         for(k=0;k<N2;k++) C[i][j] += A[i][k] * B[k][j];
      }
   }
   public void LU_D(double [][] A,double [][] L,double [][] U,int N)
   {  int i, j, k; double T;
      for(i = 0; i < N; i++) for(j = 0; j < N; j++) L[i][j] = U[i][j] = 0;
      L[0][0] = 1;
      for(j = 0; j < N; j++) U[0][j] = A[0][j]    ;
      for(i = 1; i < N; i++)
      {  U[i][0] = L[0][i] = 0;  L[i][0] = A[i][0] / U[0][0];
      }
      for(i = 1; i < N; i++)
      {
        L[i][i] = 1; T = A[i][i];
        for(k=0; k<=i; k++) T -= L[i][k] * U[k][i];
        U[i][i] = T;
        for(j=i+1; j < N; j++)
        {   U[j][i] = L[i][j] = 0;
            T = A[j][i];
            for(k = 0; k <= i; k++) T -= L[j][k] * U[k][i];
            L[j][i] = T / U[i][i];
            T = A[i][j];
            for(k = 0; k <= i; k++) T -= L[i][k] * U[k][j];
            U[i][j] = T;
         }
       }
   }

   public void drawBra(Graphics g, int X, int Y, int H)
   {  g.drawLine( X, Y, X, Y + H);g.drawLine( X, Y, X + 2,Y);g.drawLine( X,Y + H, X + 2, Y + H);
   }
   public void drawKet(Graphics g, int X, int Y, int H)
   {  g.drawLine( X, Y, X, Y + H);g.drawLine( X, Y, X - 2,Y);g.drawLine( X,Y + H, X - 2, Y + H);
   }
   public void DrawExp(Graphics g, String ope1,String ope2, int Y,
                       double [][] A,double [][] B,double [][] C,int N1,int N2)
   {  int i, j;
      g.drawString( ope1,205,Y+20);
      g.drawString( ope2,405,Y+20);
      for(i=0;i<N1;i++) for(j=0;j<N2; j++)
      {  g.drawString( "" + A[i][j], 50 + j*50,Y + i*20);
         g.drawString( "" + B[i][j],250 + j*50,Y + i*20);
         g.drawString( "" + C[i][j],450 + j*50,Y + i*20);
      }
      drawBra(g, 40, Y - 10, 50); drawKet(g,180, Y - 10, 50);
      drawBra(g,240, Y - 10, 50); drawKet(g,380, Y - 10, 50);
      drawBra(g,440, Y - 10, 50); drawKet(g,590, Y - 10, 50);
   } 
   public void paint(Graphics g)
   {  int i,j;
      double [][] A={{6,5,4},{12,13,10},{18,21,17}};
      double [][] L={{0,0,0},{0,0,0},{0,0,0}};
      double [][] U={{0,0,0},{0,0,0},{0,0,0}};
      double [][] C={{0,0,0},{0,0,0},{0,0,0}};
      setTitle("LU");
      LU_D(A, L, U, 3);
      DrawExp(g, "","", 50, A, L, U, 3,3);
      MultM(L, U, C, 3, 3, 3);
      DrawExp(g, "","", 150, L, U, C, 3,3);
   } 
   public static void main(String[] args)
   {
      Frame w = new LUDecomp();
      w.setVisible(true);
   }

}
